/*
  ؽΥҥȥ
  */
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <conf.h>
#include <ruleparser.h>
#include <record.h>

#include "dic_personality.h"

/**/
struct record_val{
  xstr str;
  int val;
};

/**/
struct record_column{
  xstr key;
  int nr_vals;
  struct record_val *vals;
  struct record_column *next;
};

/**/
struct record_section{
  char *name;
  struct record_column cols;
  struct record_section *next;
};

/*ǡ١*/
struct record_stat{
  struct record_section section;
  struct record_section *cur_section;
  struct record_column *cur_column;
  int is_dirty;
  char *id;/*ѡʥƥid*/
  char *file_name;
};

/*wrapped functions*/
static int do_select_section(struct record_stat *rs,char *name,int flag);
static int do_select_column(struct record_stat *s,xstr *name,int flag);
static void do_set_nth_value(struct record_stat *rs,int nth,int val);
static void do_set_nth_xstr(struct record_stat *rs,int nth,xstr *xs);
static int do_get_nr_values(struct record_stat *rs);
static int do_get_nth_value(struct record_stat *rs,int n);
static xstr *do_get_nth_xstr(struct record_stat *rs,int n);
static int do_select_first_column(struct record_stat *);
static int do_select_next_column(struct record_stat *);
static xstr *do_get_index_xstr(struct record_stat *);
/*functions*/
static void read_last_session(struct record_stat *);
static void read_session(struct record_stat *);
static void check_anthy_dir();
static void mk_dirty(struct record_stat *);
static void save_a_column(FILE *fp,struct record_column *);
static FILE *fopen_in_recorddir(char *,char *);
static void update_session_file();
static void free_record(struct record_stat *);
static void free_section(struct record_section *rs);
static void free_column(struct record_column *rc);
static struct record_val *get_nth_val_ent(struct record_stat *,int ,int create_if_not_exist);

FILE *fopen_in_recorddir(char *fn,char *mode)
{
  char *pn;
  char *hd;
  hd = conf_get_str("HOME");
  pn = alloca(strlen(hd)+strlen(fn)+10);
  strcpy(pn,hd);
  strcat(pn,"/.anthy/");
  strcat(pn,fn);
  return fopen(pn,mode);
}

void mk_dirty(struct record_stat *rs)
{
  rs->is_dirty = 1;
}

/*Wrappers begin..*/
int select_section(char *name,int flag)
{
  return do_select_section(gCurrentPersonality->record,name,flag);
}

int select_column(xstr *name,int flag)
{
  return do_select_column(gCurrentPersonality->record,name,flag);
}

void set_nth_value(int nth,int val)
{
  do_set_nth_value(gCurrentPersonality->record,nth,val);
}

void set_nth_xstr(int nth,xstr *xs)
{
  do_set_nth_xstr(gCurrentPersonality->record,nth,xs);
}

int get_nr_values()
{
  return do_get_nr_values(gCurrentPersonality->record);
}

int get_nth_value(int n)
{
  return do_get_nth_value(gCurrentPersonality->record,n);
}

xstr *get_nth_xstr(int n)
{
  return do_get_nth_xstr(gCurrentPersonality->record,n);
}

int select_first_column()
{
  return do_select_first_column(gCurrentPersonality->record);
}

int select_next_column()
{
  return do_select_next_column(gCurrentPersonality->record);
}

xstr *get_index_xstr()
{
  return do_get_index_xstr(gCurrentPersonality->record);
}
/*..Wrappers end*/

xstr *do_get_index_xstr(struct record_stat *rec)
{
  if ( !rec->cur_column ){
    return 0;
  }
  return &rec->cur_column->key;
}

int do_select_section(struct record_stat *rec,char *name,int flag)
{
  struct record_section *rs;
  rec->cur_column = 0;
  for ( rs = rec->section.next ;rs ; rs = rs->next ){
    if ( !strcmp(name,rs->name) ){
      rec->cur_section = rs;
      return 0;
    }
  }
  if ( flag ){
    rs = malloc(sizeof(struct record_section));
    rs->name = strdup(name);
    rs->next = rec->section.next;
    rec->section.next = rs;
    rs->cols.next = 0;
    rec->cur_section = rs;
    return 0;
  }
  return -1;
}

int do_select_column(struct record_stat *s,xstr *name,int flag)
{
  struct record_column *col;
  if ( !s->cur_section ){
    return -1;
  }
  for ( col = s->cur_section->cols.next ; col; col = col->next ){
    if (! xstrcmp(&col->key,name)){
      s->cur_column = col;
      return 0;
    }
  }
  if ( flag ){
    col = malloc(sizeof(struct record_column));
    col->key.str = xstr_dup_str(name);
    col->key.len = name->len;
    col->next = s->cur_section->cols.next;
    col->nr_vals = 0;
    col->vals = 0;
    s->cur_section->cols.next = col;
    s->cur_column = col;
    mk_dirty(s);
    return 0;
  }
  return -1;
}

int do_select_first_column(struct record_stat *rs)
{
  if ( ! rs->cur_section ){
    return -1;
  }
  if ( ! rs->cur_section->cols.next ){
    return -1;
  }
  rs->cur_column = rs->cur_section->cols.next;
  return 0;
}

int do_select_next_column(struct record_stat *rs)
{
  if ( !rs->cur_column || !rs->cur_column->next ){
    return -1;
  }
  rs->cur_column = rs->cur_column->next;
  return 0;
}

/*column*/
void free_column(struct record_column *rc)
{
  int i;
  for ( i = 0 ; i < rc->nr_vals ; i++){
    if ( rc->vals[i].str.str ){
      free(rc->vals[i].str.str );
    }
  }
  free(rc->vals);
  if ( gCurrentPersonality->record->cur_column == rc ){
    gCurrentPersonality->record->cur_column = 0;
  }
  free(rc->key.str);
  free(rc);
}

/*륻ΥǡƲ*/
void free_section(struct record_section *rs)
{
  struct record_column *rc;
  for ( rc = rs->cols.next ; rc ; ){
    struct record_column *tmp;
    tmp = rc;
    rc = rc->next;
    free_column(tmp);
  }
  if ( gCurrentPersonality->record->cur_section == rs ){
    gCurrentPersonality->record->cur_section = 0;
  }
  if ( rs->name ){
    free(rs->name);
  }
  free(rs);
}

/*٤ƤΥǡ*/
void free_record(struct record_stat *r)
{
  struct record_section *rs;
  for ( rs = r->section.next ; rs ; ){
    struct record_section *tmp;
    tmp = rs;
    rs = rs->next;
    free_section(tmp);
  }
}

struct record_val *get_nth_val_ent(struct record_stat *rs,int n,int f)
{
  struct record_column *col = rs->cur_column;
  if ( !col ){
    return 0;
  }
  if ( n < do_get_nr_values(rs) ){
    return &col->vals[n];
  }
  if ( f ){
    int i;
    col->vals = realloc(col->vals,sizeof(struct record_val)*(n+1));
    for ( i = col->nr_vals ; i < n+1 ; i++){
      col->vals[i].val = 0;
      col->vals[i].str.str = 0;
      col->vals[i].str.len = 0;
    }
    rs->cur_column->nr_vals = n+1;
    return &rs->cur_column->vals[n];
  }
  return 0;
}

int do_get_nr_values(struct record_stat *rs)
{
  if ( rs->cur_column ){
    return rs->cur_column->nr_vals;
  }
  return 0;
}

int do_get_nth_value(struct record_stat *rs,int n)
{
  struct record_val *v = get_nth_val_ent(rs,n,0);
  if ( v ){
    return v->val;
  }
  return 0;
}

xstr *do_get_nth_xstr(struct record_stat *rs,int n)
{
  struct record_val *v = get_nth_val_ent(rs,n,0);
  if ( v && v->str.str ){
    return &v->str;
  }
  return 0;
}

void do_set_nth_value(struct record_stat *rs,int nth,int val)
{
  struct record_val *v = get_nth_val_ent(rs,nth,1);
  if ( !v ){
    return ;
  }
  mk_dirty(rs);
  v->val = val;
}

void do_set_nth_xstr(struct record_stat *rs,int nth,xstr *xs)
{
  struct record_val *v = get_nth_val_ent(rs,nth,1);
  if ( !v ){
    return ;
  }
  if ( v->str.str ){
    free(v->str.str);
  }
  v->str.str = xstr_dup_str(xs);
  v->str.len = xs->len;
  mk_dirty(rs);
}

void release_section()
{
  if ( !gCurrentPersonality->record->cur_section ){
    return ;
  }
  free_section(gCurrentPersonality->record->cur_section);
  gCurrentPersonality->record->cur_section = 0;
}

void release_column()
{
  struct record_column *rc;
  if ( ! gCurrentPersonality->record->cur_section || !gCurrentPersonality->record->cur_column ){
    return ;
  }
  for ( rc = &gCurrentPersonality->record->cur_section->cols ; rc->next ; rc = rc->next){
    if ( rc->next == gCurrentPersonality->record->cur_column ){
      struct record_column *tmp;
      tmp = rc->next->next;
      free_column(rc->next);
      rc->next = tmp;
      return ;
    }
  }
}

void check_anthy_dir()
{
  char *hd;
  char *dn;
  struct stat st;
  hd = conf_get_str("HOME");
  dn = alloca(strlen(hd)+10);
  strcpy(dn,hd);
  strcat(dn,"/.anthy/");
  if ( stat(dn,&st) || !S_ISDIR(st.st_mode)){
    int r;
    printf("Failed to open anthy directory(%s).\n",dn);
    r = mkdir(dn,S_IRWXU);
    if ( r == -1){
      printf("Failed to create\n");
      return ;
    }
    printf("Created\n");
    r = chmod(dn,S_IRUSR|S_IWUSR|S_IXUSR);
    if ( r == -1 ){
      printf("But failed to change permission.\n");
    }
  }
}

void read_session(struct record_stat *r)
{
  char **tokens;
  int nr;
  int s = 0;
  while( !read_line(&tokens,&nr) ){
    if ( !strcmp(tokens[0],"---") && nr >1 ){
      s = 1;
      do_select_section(r,tokens[1],1);
    }else if ( s == 1 && nr>1){
      xstr *xs;
      int i;
      xs = cstr_to_xstr(tokens[0]);
      if ( do_select_column(r,xs,1) == -1 ){
	putxstr(xs);
	printf("aho\n");
      }
      free_xstr(xs);
      for ( i = 1 ; i < nr ; i++){
	if ( tokens[i][0] == '"' ){
	  char *str;
	  str = strdup(&tokens[i][1]);
	  str[strlen(str)-1] = 0;
	  xs = cstr_to_xstr(str);
	  free(str);
	  do_set_nth_xstr(r,i-1,xs);
	  free_xstr(xs);
	}else{
	  do_set_nth_value(r,i-1,atoi(tokens[i]));
	}
      }
    }
    free_line();
  }
  close_file();
  r->is_dirty = 0;
}

void read_last_session(struct record_stat *r)
{
  char *pn,*hd;
  check_anthy_dir();
  hd = conf_get_str("HOME");/*ۡǥ쥯ȥ*/
  pn = alloca(strlen(hd)+strlen(r->file_name)+1);/*եѥ*/
  strcpy(pn,hd);
  strcat(pn,r->file_name);
  if ( open_file(pn) == 0 ){
      free_record(r);
      read_session(r);
  }
}

void update_session_file()
{
  char *hd,*fn1,*fn2;
  char *sid;
  hd = conf_get_str("HOME");
  sid = conf_get_str("SESSION-ID");
  fn1 = alloca(strlen(hd)+strlen(sid)+10);
  fn2 = alloca(strlen(hd)+strlen(gCurrentPersonality->record->file_name)+1);
  strcpy(fn1,hd);
  strcat(fn1,"/.anthy/");
  strcat(fn1,sid);
  strcpy(fn2,hd);
  strcat(fn2,gCurrentPersonality->record->file_name);
  if ( rename(fn1,fn2) ){
    printf("Failed to update record file %s -> %s.\n",fn1,fn2);
  }
}

void save_a_column(FILE *fp,struct record_column *c)
{
  int i;
  char *buf = malloc(c->key.len *2 +2);
  sputxstr(buf,&c->key);
  fprintf(fp,"%s ",buf);
  for ( i = 0 ; i < c->nr_vals ; i++){
    struct record_val *val = &c->vals[i];
    if ( val->str.str ){
      buf = realloc(buf,val->str.len*2+2);
      sputxstr(buf,&val->str);
      fprintf(fp,"\"%s\" ",buf);
    }else{
      fprintf(fp,"%d ",val->val);
    }
  }
  fprintf(fp,"\n");
  free(buf);
}

void save_record()
{
  struct record_section *sec;
  struct record_column *col;
  char *sid;
  FILE *fp;
  if ( !gCurrentPersonality->record->is_dirty ){
    return ;
  }
  sid = conf_get_str("SESSION-ID");
  fp = fopen_in_recorddir(sid,"w");
  if ( ! fp ){
    printf("Failed to open temporaly session file.\n");
    return ;
  }
  for ( sec = gCurrentPersonality->record->section.next ; sec ; sec = sec->next ){
    if ( !sec->cols.next ){
      /*Υ϶*/
      continue;
    }
    fprintf(fp,"--- %s\n",sec->name);
    for ( col = sec->cols.next ; col ; col = col->next ){
      save_a_column(fp,col);
    }
  }
  fclose(fp);
  gCurrentPersonality->record->is_dirty = 0;
  update_session_file();
}

void init_record()
{
}

struct record_stat *create_record(char *id)
{
  struct record_stat *rs;
  char *fn = alloca(25+strlen(id));
  strcpy(fn,"/.anthy/last-record:");
  strcat(fn,id);

  rs = malloc(sizeof(struct record_stat));
  rs->id = id;
  rs->is_dirty = 0;
  rs->section.next = 0;
  rs->cur_section = 0;
  rs->cur_column = 0;
  rs->file_name = strdup(fn);
  read_last_session(rs);
  return rs;
}

void release_record(struct record_stat *rs)
{
  free_record(rs);
  free(rs->file_name);
  free(rs);
}
