#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <dicutil.h>

#define UNSPEC 0
#define DUMP_DIC 1

static int command=UNSPEC;
static char *personality="";

static void print_usage()
{
  printf(
	 "Anthy-dic-util [options]\n"
	 " --help: Show this usage text\n"
	 " --version: Show version\n"
	 " --dump: Dump dictionaly\n");
  exit(0);
}

static void dump_dic()
{
  if ( priv_dic_select_first_entry() == -1 ){
    printf("#Fail\n");
    return ;
  }
  do{
    char buf[100];
    if ( priv_dic_get_index(buf,100) ){
      printf("%s\n",buf);
    }
  }while( priv_dic_select_next_entry() == 0);
}

static void print_version()
{
  printf("Anthy-dic-util "VERSION".\n");
  exit(0);
}

static void parse_args(int argc,char **argv)
{
  int i;
  for ( i = 1 ; i < argc ; i++ ){
    if ( !strncmp(argv[i],"--",2)){
      char *opt = &argv[i][2];
      if ( !strcmp(opt,"help" ) ){
	print_usage();
      }else if ( !strcmp(opt,"version" ) ){
	print_version();
      }else if ( !strcmp(opt,"dump") ){
	command = DUMP_DIC;
      }
    }
  }
}

int main(int argc,char **argv)
{
  parse_args(argc,argv);

  switch(command){
  case DUMP_DIC:
    dic_util_init();
    dump_dic();
    break;
  case UNSPEC:
  default:
    printf("This program does nothing at current release.\n");
  }
  return 0;
}
